As we know, there are some boring tasks while deploy Django project, like create db, do migrations and so on, here I wrote a shell script to auto do these things

#!/bin/bash

# The shell is used to do some prepare tasks for deploying TMS, including:
# (1) create new user to run TMS;
# (2) create database and add privileges;
# (3) extract software to the new user's home directionay;
# (4) modify the system database related configuration;
# (5) create necessary tables for TMS;
# (6) add administartor for TMS;
# (7) run MQ as a daemon;
# (8) deploy TMS with nginx.
# Note: please exec this sh as root. PACKAGE='tms-1.0.tar.gz' echo "The processing will spend several mins, please waiting patiently..." echo "(1) create new user to run TMS"
USER='tmsx'
ACCOUNT_NUM=`cat /etc/passwd | grep "$USER" |wc -l` if [ $ACCOUNT_NUM -eq 0 ] && [ ! -d "/home/$USER" ]
then
echo "Please enter user password, default is '123456'"
read USER_PASSWORD
[ "${USER_PASSWORD}" == "" ] && USER_PASSWORD='123456'
useradd $USER -p `openssl passwd -1 ${USER_PASSWORD}` -d /home/$USER -m -c "termianl manage system default user"
echo "$USER ALL=NOPASSWD:ALL" >> /etc/sudoers
if [ $? -eq 0 ]
then
su $USER -c 'echo "" | ssh-keygen -t rsa'
fi
fi
echo "" echo "(2) create database and add privileges, "
echo "Please enter database host, default is 'localhost'"
read HOST
[ "$HOST" == "" ] && HOST='localhost' echo "Please enter the database root user password"
read ROOT_PASSWORD
[ "$ROOT_PASSWORD" == "" ] && echo "Need root password" && exit 1 DBNAME='tmsx'
MYSQL_CMD="mysql -h${HOST} -uroot -p${ROOT_PASSWORD}" CREATE_DB_SQL="CREATE DATABASE IF NOT EXISTS ${DBNAME} CHARACTER SET utf8;"
echo ${CREATE_DB_SQL} | ${MYSQL_CMD} if [ $? -ne 0 ]
then
echo "create database failed..."
exit 1
fi GRANT_PRIVILEGES_SQL="GRANT ALL PRIVILEGES ON ${DBNAME}.* TO '${USER}'@'%' IDENTIFIED BY '${USER_PASSWORD}';"
echo ${GRANT_PRIVILEGES_SQL} | ${MYSQL_CMD} if [ $? -ne 0 ]
then
echo "grant failed..."
exit 1
fi
echo "" echo "(3) extract software to the new user's home directionay"
if [ -d /home/$USER ]
then
cp $PACKAGE /home/$USER
cd /home/$USER
tar xf $PACKAGE
else
echo "no dir /home/$USER"
exit 1
fi
echo "" echo "(4)modify the system database related configuration"
TARGET=`basename $PACKAGE .tar.gz`
DB_SETTING=" DATABASES = {
'default': {
'ENGINE': 'django.db.backends.mysql',
'HOST': '${HOST}',
'NAME': '${DBNAME}',
'USER': '${USER}',
'PASSWORD': '${USER_PASSWORD}',
}
}" if [ -d /home/$USER/$TARGET ] && [ -f /home/$USER/$TARGET/tms/settings.py ]
then
echo $DB_SETTING >> /home/$USER/$TARGET/tms/settings.py
else
echo "modify the system database related configuration"
exit 1
fi
echo "" echo "(5) create necessary tables for TMS"
if [ -d /home/$USER/$TARGET ]
then
cd /home/$USER/$TARGET
python manage.py makemigrations tmsApp && python manage.py migrate
fi
echo "" if [ $? -ne 0 ]
then
echo "create tables for TMS failed..."
exit 1
fi echo "(6) add administartor for TMS"
if [ -f /home/$USER/$TARGET/manage.py ]
then
cd /home/$USER/$TARGET
python manage.py createsuperuser
fi
echo "" echo "(7) run MQ as a daemon"
MQ_SETTING=" description \"TMS MQ daemon\"
author \"<Andy Wu>\" start on startup
stop on shutdown respawn
respawn limit 20 5 pre-start script
end script script
python /home/$USER/$TARGET/manage.py runMSGServer
end script post-start script
end script" DAEMON_CFG_FILE='/etc/init/tms-mq.conf'
if [ -f $DAEMON_CFG_FILE ]
then
status=`service tms-mq status`
ret=`echo $status | grep 'running' | wc -l`
if [ "$ret" != "0" ]; then
echo >&1 "ERROR: tms-mq daemon already run."
exit 1
fi
fi echo "$MQ_SETTING" > $DAEMON_CFG_FILE status=`service tms-mq status`
ret=`echo $status | grep 'waiting' | wc -l`
if [ "$ret" = "0" ]; then
echo >&1 "ERROR: Could not add tms-mq daemon"
exit 1
fi service tms-mq start
sleep 1
status=`service tms-mq status`
ret=`echo $status | grep 'running' | wc -l`
if [ "$ret" = "0" ]; then
echo >&1 "ERROR: Could not start tms-mq daemon"
exit 1
fi echo "" echo "(8) deploy TMS with nginx" # install nginx if need if grep "Ubuntu" /etc/issue
then
if ! dpkg -l | grep "nginx"
then
apt-get install python-dev nginx || exit 1
fi
fi if grep "CentOS" /etc/issue
then
if ! yum list nginx
then
yum install epel-release
yum install python-devel nginx || exit 1
fi
fi if ! pip list | grep supervisor
then
pip install supervisor || exit 1
fi if ! pip list | grep uwsgi
then
pip install uwsgi || exit 1
fi echo_supervisord_conf > /etc/supervisord.conf SUPERVISORD="
[program:tms]\n
command=uwsgi --ini /home/$USER/$TARGET/uwsgi.ini\n
directory=/home/$USER/$TARGET\n
startsecs=0\n
stopwaitsecs=0\n
autostart=true\n
autorestart=true\n" echo $SUPERVISORD >> /etc/supervisord.conf supervisord -c /etc/supervisord.conf supervisorctl -c /etc/supervisord.conf restart tms if [ ! -f /home/$USER/$TARGET/reload ]
then
echo > /home/$USER/$TARGET/reload
fi UWSGI="
[uwsgi]\n
socket = 127.0.0.1:8077\n
chdir = /home/$USER/$TARGET\n
wsgi-file = tms/wsgi.py\n
touch-reload=/home/$USER/$TARGET/reload\n processes = 2\n
threads = 4\n chmod-socket = 664\n
chown-socket=$USER:www-data\n" echo -e $UWSGI > /home/$USER/$TARGET/uwsgi.ini #restart supervisor
supervisorctl -c /etc/supervisord.conf restart tms #config nginx
TMS_CONF="
server {
listen 80;
server_name localhost;
charset utf-8; client_max_body_size 75M; location /static {
alias /home/$USER/$TARGET/static;
} location / {
include uwsgi_params;
uwsgi_pass 127.0.0.1:8077;
}
}" echo -e $TMS_CONF > /etc/nginx/sites-available/tms.conf ln -s /etc/nginx/sites-available/tms.conf /etc/nginx/sites-enabled/tms.conf service nginx reload echo "Congratulations!"

Prepare tasks for django project deployment.md的更多相关文章

  1. [Python] Create a Django project in Pycharm

    From: http://blog.csdn.net/u013088062/article/details/50158239 From: http://blog.csdn.net/u013088062 ...

  2. Web.config Transformation Syntax for Web Application Project Deployment

    Web.config Transformation Syntax for Web Application Project Deployment Other Versions   Updated: Ma ...

  3. Start Your Django Project in Nginx with uWsgi

    Step 0:Install A,B,C,blabla needed This can be seen in my another article in the blog.click here(una ...

  4. Apache:To Config The Vhost of Django Project

    It is not a good idea to use dev server in Production Environment. Apache or Nginx are good choice.B ...

  5. Django project troubleshootings

    1. 当django project文件夹放到cgi-bin目录下面时会出现下面的错误: [Wed Jan 09 01:52:52.611690 2019] [core:notice] [pid 15 ...

  6. django project 的快速构建

    2003年,堪萨斯(Kansas)州 Lawrence 城中的一个 网络开发小组 ——World Online 小组,为了方便制作维护当地的几个新闻站点(一般要求几天或者几小时内被建立),Adrian ...

  7. 18 12 30 新建一个 django project

    1. 新建一个 django project 1 2 django-admin.py startproject project_name 特别是在 windows 上,如果报错,尝试用 django- ...

  8. Django project structure: how does static folder, STATIC_URL, STATIC_ROOT work

    So I've been messing up with Django(1.6+) project setting for quite sometime, this is what i finally ...

  9. PyCharm‘s Project Deployment

    当在本地写完项目,部署到服务器上调试的时候,难免会碰到代码的修修改改,但由于项目在服务器上,修改起来相对麻烦.各路大神或许有自己的方法去解决.这篇博客演示利用PyCharm的Deployment功能, ...

随机推荐

  1. MT【131】$a_{n+1}\cdot a_n=\dfrac 1n$

    已知数列\(\{a_n\}\)满足\(a_1=1\),\(a_{n+1}\cdot a_n=\dfrac 1n\)(\(n\in\mathbb N^*\)). (1) 求证:\(\dfrac{a_{n ...

  2. BZOJ 3110 K大数查询 | 整体二分

    BZOJ 3110 K大数查询 题面 有N个位置,M个操作.操作有两种,每次操作如果是1 a b c的形式表示在第a个位置到第b个位置,每个位置加入一个数c 如果是2 a b c形式,表示询问从第a个 ...

  3. 【Cf #502 F】The Neutral Zone

    本题把$log$化简之后求得就是每个质数$f$前的系数,求系数并不难,难点在于求出所有的质数. 由于空间限制相当苛刻,$3e8$的$bitset$的内存超限,我们考虑所有的除了$2$和$3$以外的质数 ...

  4. Mac显示同一程序的所有窗口

    通过F3键可以显示所有程序的所有窗口到桌面,但是如果窗口太多的话显示出来很难看清. 如果只显示某一个程序的所有窗口就不会乱了. 其实在dock上有一个相应的选项,但是没有快捷键. 开启方法: 在终端上 ...

  5. python学习(20) 网络编程

    原文链接:http://www.limerence2017.com/2018/01/02/python20/ python 网络编程和基本的C语言编程一样,效率不是很高,如果为了封装通信库建议采用C/ ...

  6. 【Asp.net入门3-03】jQuery-选择元素

    练习:使用jQuery实现一个可以给table增加.删除行的页面 HTML代码: <body> <input type="button" value=" ...

  7. java基础-引用数据类型之二维数组(Array)

    java基础-引用数据类型之二维数组(Array) 作者:尹正杰 版权声明:原创作品,谢绝转载!否则将追究法律责任. 之前我们学习过了Java的一维数组,所谓的二维数组就是元素是一堆一维数组的数组,换 ...

  8. c# string 和 byte[]数组之间转换

    在文件流读取和存储过程当中,经常涉及到byte[]数组形式存储数据,再此过程中也涉及到String类型字符串和byte[]的类型转换,下面我们举例说明一下. 现在有一个字符串: string str ...

  9. 2017 清北济南考前刷题Day 1 morning

    期望得分:100+100+50=250 实际得分:100+60+50=210 T2 二分 估错上界.估错复杂度 T1 立方数(cubic) Time Limit:1000ms   Memory Lim ...

  10. 用 Love2D 实现法线贴图的例程(到最新版本 0.10.1)

    用 Love2D 实现法线贴图的例程(到最新版本 0.10.1) 概述 一般来说, 复杂的光照模型会被用在 3D 游戏中, 以产生逼真的效果, 不过也有些开发者研究出一些代码可以在 2D 游戏中使用这 ...